



# This puts a Newick string gtree in a file with a name like "genetree2.txt".
# Then it calls seqgen to get a sequence file like "seq2.txt"
make.sequence.file <- function(g, gtree, seed,
                  filepaths, seqgenbasecmd, len) {
  gnum <- as.character(g)
  gtreefname <- paste(filepaths$gtree, gnum, ".txt", sep="")
  sink(gtreefname)
  cat(gtree)
  sink(NULL)

  seqsfname <- paste(filepaths$seq, gnum, ".txt", sep="")
  SeqGen.cmd <- paste(seqgenbasecmd, " -l", len, " -n1 -z", seed, 
                     " ", gtreefname, " -y ", seqsfname, sep="")
  cat("Running seqgen with command:", SeqGen.cmd, "\n")
  system(SeqGen.cmd)

  }
