#                             DISSECT.

# Started 2013-10-23 
# This is for analysing results



library(ape)
library(phangorn)

################################################################################
###################### Setting up file paths, loading code #####################


# Where this code is
setwd("C:/Users/Graham/AAA/Programming/biology/SpeciesDelimSimulations")
 
# Code providing functions
source("DISSECT_1readconfig-pparams.r")
source("DISSECT_1readconfig-GNT.r")



################################################################################
######################### Top level functions ##################################



simmatrix.from.clusterings <- function(x) {
  # Minimal cluster names are column names omitting first 4 
  mincl.names <- colnames(x)[-(1:4)]
  # Make the similarity matrix  
  nmincls <- length(mincl.names)
  sim <- matrix(0, ncol=nmincls, nrow=nmincls, dimnames=list(mincl.names, mincl.names))
  for (i in 1:nmincls) {
    for (j in 1:nmincls) {
      coli <- x[,mincl.names[i]]
      colj <- x[,mincl.names[j]]
      w <- coli == colj
      sim[i,j] <- sum(x[w,"fraction"])
    }
  }
  sim
}


true.simmatrix.5.5 <- function() {
  sim <- matrix(0, ncol=25, nrow=25)
  for (i in 1:25) {
    for (j in 1:25) {
      trupairsame <- (floor((i-1)/5) == floor((j-1)/5))
      if (trupairsame) {
        sim[i,j] <- 1
        }
     }
  }  
sim
}
  
 
 
simmatrixdist <- function(x, y)   {
  n <- ncol(x)
  sum(abs(x-y))/(n*(n-1))
}


  
################################################################################
########################## Business starts here ################################

# input config is here. All output goes in subdirectories of this
CONFIG.DIR <- "C:/Users/Graham/AAA/Programming/tmp/dissect/E"
CONFIG <- read.config()

cat("Config has been read\n")

nofGNT <- length(CONFIG$configG)




cat.array <- function(x) {
  cat(" <- c(")
  for (i in 1:length(x)) {
    cat(x[i], sep="") 
    if (i < length(x)) {
      cat(",")
    }
  }
  cat(")\n")
}


truesimm <- true.simmatrix.5.5()
  
for (i in 1:nofGNT) {
  R <- CONFIG$configR[i]
  meansimmdists <- rep(0, R)
  for (r in 1:R) {
    totalsimmdist <- 0
    totalcount <- 0
    clusterings <- read.table(fpath.clusterings(CONFIG, i, r), header=TRUE)
    simm <- simmatrix.from.clusterings(clusterings)
    meansimmdists[r] <- simmatrixdist(truesimm, simm)
  }   
  cat.array(meansimmdists)
  plot(meansimmdists)
}



